OptionsWindow = class( Turbine.UI.Lotro.Window )

function OptionsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self )
	
	self:SetSize(500,750)
	self:SetText("SkillTimer")
	self:SetPosition(300,200)
	self:SetVisible(true)

	self.selectedWindow = 1
	self.selectedItem = 1
	
	self.move = Turbine.UI.Lotro.CheckBox()
	self.move:SetParent(self)
	self.move:SetPosition(30,50)
	self.move:SetSize(300,20)
	self.move:SetText(" Moveable")
	
	self.move.CheckedChanged = function(sender,args)
		MoveWindows(self.move:IsChecked())
	end
	
	self.reload = Turbine.UI.Lotro.Button()
	self.reload:SetParent(self)
	self.reload:SetPosition(350,50)
	self.reload:SetWidth(100)
	self.reload:SetText("Reload")
	
	self.reload.Click = function(sender,args)

		CreateWindows()
	
	end
	
	self.windowOptions = WindowOptionControl(self)
	self.itemOptions = ItemOptionControl(self)
	self.itemOptions:SetTop(self.windowOptions:GetHeight()+self.windowOptions:GetTop())
	
	self.accept = Turbine.UI.Lotro.Button()
	self.accept:SetParent(self)
	self.accept:SetPosition(350,self.itemOptions:GetTop()+self.itemOptions:GetHeight())
	self.accept:SetWidth(100)
	self.accept:SetText("Accept")
	
	self.accept.Click = function(sender,args)
	
		self.move:SetChecked(false)
		self:SaveChanges()
		CreateWindows()
		self.itemOptions:UpdateColor()
	
	end
	
	self:UpdateContent()
	
end

function OptionsWindow:SaveChanges()


	if table.getn(SaveFile) > 0 then

		SaveFile[self.selectedWindow]["name"] = self.windowOptions.rename:GetText()
		SaveFile[self.selectedWindow]["visible"] = self.windowOptions.visible:IsChecked()
		SaveFile[self.selectedWindow]["orientation"] = self.windowOptions.orientation:IsChecked()
		SaveFile[self.selectedWindow]["distance"] = tonumber(self.windowOptions.distance:GetText())
		SaveFile[self.selectedWindow]["opacity"] = tonumber(self.windowOptions.opacity:GetText())
		SaveFile[self.selectedWindow]["size"] = tonumber(self.windowOptions.size:GetText()) 
		
		
		if table.getn(SaveFile[self.selectedWindow]) > 0 then

			local colorList = mysplit(self.itemOptions.color:GetText(), ",")
			if table.getn(colorList) == 3 then
				
				SaveFile[self.selectedWindow][self.selectedItem]["thresholdColor"] ={}
			
				SaveFile[self.selectedWindow][self.selectedItem]["thresholdColor"]["R"] = (tonumber(colorList[1])/255)
				SaveFile[self.selectedWindow][self.selectedItem]["thresholdColor"]["G"] = (tonumber(colorList[2])/255)
				SaveFile[self.selectedWindow][self.selectedItem]["thresholdColor"]["B"] = (tonumber(colorList[3])/255)
			end
		
			SaveFile[self.selectedWindow][self.selectedItem]["name"]      = self.itemOptions.quickslotLabel:GetText()
			SaveFile[self.selectedWindow][self.selectedItem]["showoffcd"] = self.itemOptions.showoffcd:IsChecked()
			SaveFile[self.selectedWindow][self.selectedItem]["showoncd"] = self.itemOptions.showoncd:IsChecked()
			SaveFile[self.selectedWindow][self.selectedItem]["cdopacity"] = tonumber(self.itemOptions.cdopacity:GetText())
			SaveFile[self.selectedWindow][self.selectedItem]["showpopup"] = self.itemOptions.showpopup:IsChecked()
			SaveFile[self.selectedWindow][self.selectedItem]["popupsize"] = tonumber(self.itemOptions.popupsize:GetText())
			SaveFile[self.selectedWindow][self.selectedItem]["popupanchor"] = self.itemOptions.toggleanchor:IsChecked()
					
			SaveFile[self.selectedWindow][self.selectedItem]["alignment"] = self.itemOptions.selectAlignment:GetSelection()	
			SaveFile[self.selectedWindow][self.selectedItem]["font"] = self.itemOptions.selectFont:GetSelection()	
			SaveFile[self.selectedWindow][self.selectedItem]["thresholdValue"] = tonumber(self.itemOptions.thresholdValue:GetText())
			SaveFile[self.selectedWindow][self.selectedItem]["thresholdAlignment"] = self.itemOptions.selectThresholdAlignment:GetSelection()	
			SaveFile[self.selectedWindow][self.selectedItem]["thresholdFont"] = self.itemOptions.selectThresholdFont:GetSelection()	

			
			if self.itemOptions.toggelReset:IsChecked() then
				SaveFile[self.selectedWindow][self.selectedItem]["resetTimer"] = 0
			else
				SaveFile[self.selectedWindow][self.selectedItem]["resetTimer"] = tonumber(self.itemOptions.resetTimer:GetText())
			end
			
			if self.itemOptions.quickslot:GetShortcut():GetType() == Turbine.UI.Lotro.ShortcutType.Skill then
					
				SaveFile[self.selectedWindow][self.selectedItem]["data"] = self.itemOptions.quickslot:GetShortcut():GetData()
			
			else
				
				SaveFile[self.selectedWindow][self.selectedItem]["data"] = nil
				
			end
			
			self.windowOptions.select:RemoveItem(self.selectedWindow)
			self.windowOptions.select:AddItem(SaveFile[self.selectedWindow]["name"], self.selectedWindow, self.selectedWindow)
			self.windowOptions.select:SetSelection(self.selectedWindow)

			self.itemOptions.select:RemoveItem(self.selectedItem)
			self.itemOptions.select:AddItem(SaveFile[self.selectedWindow][self.selectedItem]["name"], self.selectedItem, self.selectedItem)
			self.itemOptions.select:SetSelection(self.selectedItem)

		end

	end

	Save()

end

function OptionsWindow:UpdateContent()

	self.windowOptions:UpdateContent()
	self.itemOptions:UpdateContent()

end

WindowOptionControl = class( Turbine.UI.Control )

function WindowOptionControl:Constructor(parent)
	Turbine.UI.Control.Constructor( self )
	
	self:SetParent(parent)
	self:SetSize(500,170)
	self:SetTop(100)
	
	self.heading = Turbine.UI.Label()
	self.heading:SetParent(self)
	self.heading:SetSize(100,30)
	self.heading:SetPosition(30,0)
	self.heading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.heading:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	self.heading:SetText("Window")
	
	self.select = LabelledComboBox(nil, nil, 160)
	self.select:SetParent(self)
	self.select:SetPosition(30,40)
	
	self.remove = Turbine.UI.Lotro.Button()
	self.remove:SetParent(self)
	self.remove:SetPosition(200,40)
	self.remove:SetWidth(70)
	self.remove:SetText("Remove")
	
	self.remove.Click = function()
	
		RemoveWindow(self:GetParent().selectedWindow)
		self:GetParent().selectedWindow = 1
		self:GetParent():UpdateContent()
	
	end
	
	self.new = Turbine.UI.Lotro.Button()
	self.new:SetParent(self)
	self.new:SetPosition(280,40)
	self.new:SetWidth(50)
	self.new:SetText("New")

	self.visible = Turbine.UI.Lotro.CheckBox()
	self.visible:SetParent(self)
	self.visible:SetPosition(350,40)
	self.visible:SetSize(150,20)
	self.visible:SetText(" Load")
	
	self.rename = Turbine.UI.Lotro.TextBox()
	self.rename:SetParent(self)
	self.rename:SetPosition(30,68)
	self.rename:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.rename:SetSize(160,25)
	
	self.orientation = Turbine.UI.Lotro.CheckBox()
	self.orientation:SetParent(self)
	self.orientation:SetPosition(30,100)
	self.orientation:SetSize(300,20)
	self.orientation:SetText(" Orientation (Checked = Vertical)")
	
	--SIZE
	
	self.size = Turbine.UI.Lotro.TextBox()
	self.size:SetParent(self)
	self.size:SetPosition(30,130)
	self.size:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.size:SetSize(50,25)
	
	self.sizeLabel = Turbine.UI.Label()
	self.sizeLabel:SetParent(self)
	self.sizeLabel:SetPosition(90,130)
	self.sizeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.sizeLabel:SetSize(50,25)
	self.sizeLabel:SetText("Size")

	--DISTANCE
	
	self.distance = Turbine.UI.Lotro.TextBox()
	self.distance:SetParent(self)
	self.distance:SetPosition(160,130)
	self.distance:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.distance:SetSize(50,25)
	
	self.distanceLabel = Turbine.UI.Label()
	self.distanceLabel:SetParent(self)
	self.distanceLabel:SetPosition(220,130)
	self.distanceLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.distanceLabel:SetSize(60,25)
	self.distanceLabel:SetText("Spacing")
	
	--OPACITY
	
	self.opacity = Turbine.UI.Lotro.TextBox()
	self.opacity:SetParent(self)
	self.opacity:SetPosition(290,130)
	self.opacity:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.opacity:SetSize(50,25)
	
	self.opacityLabel = Turbine.UI.Label()
	self.opacityLabel:SetParent(self)
	self.opacityLabel:SetPosition(350,130)
	self.opacityLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.opacityLabel:SetSize(50,25)
	self.opacityLabel:SetText("Opacity")
	
	self.new.Click = function(sender,args)
	
		self:GetParent():SaveChanges()
		CreateWindows()
		local value =  AddNewWindow()
		self:GetParent().selectedWindow = value
		self:GetParent():UpdateContent()
		
	end
end

function WindowOptionControl:FillSelected(value)

	self:GetParent().selectedWindow = value
	
	local window = SaveFile[value]
	
	self.rename:SetText(window["name"])
	self.visible:SetChecked(window["visible"])
	self.orientation:SetChecked(window["orientation"])
	self.size:SetText(window["size"])
	self.distance:SetText(window["distance"])
	self.opacity:SetText(window["opacity"])
	
	self:GetParent().itemOptions:UpdateContent()

end

function WindowOptionControl:FillSelect()

	self.select:Clear()
	if table.getn(SaveFile) > 0 then
		for i,windows in ipairs(SaveFile) do
			self.select:AddItem(windows["name"],i,i)
		end
		
		self.select:SetSelection(self:GetParent().selectedWindow)
		self:FillSelected(self:GetParent().selectedWindow)
	end

end

function WindowOptionControl:UpdateContent()

	self:FillSelect()

end



ItemOptionControl = class( Turbine.UI.Control )

function ItemOptionControl:Constructor(parent)
	Turbine.UI.Control.Constructor( self )

	self:SetParent(parent)
	self:SetSize(500,440)
	
	self.heading = Turbine.UI.Label()
	self.heading:SetParent(self)
	self.heading:SetSize(100,30)
	self.heading:SetPosition(30,10)
	self.heading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.heading:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	self.heading:SetText("Skill")
	
	self.select = LabelledComboBox(nil, nil, 230)
	self.select:SetParent(self)
	self.select:SetPosition(30,50)
	
	self.remove = Turbine.UI.Lotro.Button()
	self.remove:SetParent(self)
	self.remove:SetPosition(270,50)
	self.remove:SetWidth(70)
	self.remove:SetText("Remove")
	
	self.remove.Click = function()
	
		RemoveItem(self:GetParent().selectedWindow, self:GetParent().selectedItem)
		self:GetParent().selectedItem = 1
		self:UpdateContent()
	
	end
	
	self.new = Turbine.UI.Lotro.Button()
	self.new:SetParent(self)
	self.new:SetPosition(350,50)
	self.new:SetWidth(50)
	self.new:SetText("New")
	
	self.quickslot = Turbine.UI.Lotro.Quickslot()
	self.quickslot:SetParent(self)
	self.quickslot:SetPosition(30,90)
	self.quickslot:SetSize(38,38)
	self.quickslot:SetBackColor(Turbine.UI.Color.White)
	
	self.quickslotLabel = Turbine.UI.Lotro.TextBox()
	self.quickslotLabel:SetParent(self)
	self.quickslotLabel:SetPosition(90,95)
	self.quickslotLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.quickslotLabel:SetSize(170,25)
	
	self.changePosLabel = Turbine.UI.Label()
	self.changePosLabel:SetParent(self)
	self.changePosLabel:SetPosition(275,90)
	self.changePosLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
	self.changePosLabel:SetSize(200,25)
	self.changePosLabel:SetText("Change Position")
	
	self.posUp = Turbine.UI.Lotro.Button()
	self.posUp:SetParent(self)
	self.posUp:SetPosition(270,105)
	self.posUp:SetWidth(70)
	self.posUp:SetText("Up/Left")
	
	self.posUp.Click = function()
	
		local index = self:GetParent().selectedItem
		if SwapItem(self:GetParent().selectedWindow, index, index-1) then
			self:FillSelect(index-1)
		end
	end

	self.posDown = Turbine.UI.Lotro.Button()
	self.posDown:SetParent(self)
	self.posDown:SetPosition(350,105)
	self.posDown:SetWidth(80)
	self.posDown:SetText("Down/Right")	
	
	self.posDown.Click = function()
		
		local index = self:GetParent().selectedItem
		if SwapItem(self:GetParent().selectedWindow, index, index+1) then
			self:FillSelect(index+1)
		end
	
	end

	self.showoffcd = Turbine.UI.Lotro.CheckBox()
	self.showoffcd:SetParent(self)
	self.showoffcd:SetPosition(30,140)
	self.showoffcd:SetSize(300,20)
	self.showoffcd:SetText(" Show off CD")
		
	self.showoncd = Turbine.UI.Lotro.CheckBox()
	self.showoncd:SetParent(self)
	self.showoncd:SetPosition(160,140)
	self.showoncd:SetSize(300,20)
	self.showoncd:SetText(" Show on CD")
	
	self.cdopacity = Turbine.UI.Lotro.TextBox()
	self.cdopacity:SetParent(self)
	self.cdopacity:SetPosition(30,170)
	self.cdopacity:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.cdopacity:SetSize(50,25)
	
	self.cdopacityLabel = Turbine.UI.Label()
	self.cdopacityLabel:SetParent(self)
	self.cdopacityLabel:SetPosition(90,170)
	self.cdopacityLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.cdopacityLabel:SetSize(200,25)
	self.cdopacityLabel:SetText("Opacity while skill is on CD")
	
	self.showpopup = Turbine.UI.Lotro.CheckBox()
	self.showpopup:SetParent(self)
	self.showpopup:SetPosition(30,207)
	self.showpopup:SetSize(300,20)
	self.showpopup:SetText(" Show Pop-Up")
	
	self.showpopup.CheckedChanged = function()
	
		if self.showpopup:IsChecked() then
		
			self.popupsize:SetEnabled(true)
			self.popupsizeLabel:SetEnabled(true)
			self.toggleanchor:SetEnabled(true)
			
		else
		
			self.popupsize:SetEnabled(false)
			self.popupsizeLabel:SetEnabled(false)
			self.toggleanchor:SetEnabled(false)
						
		end
	
	end
	
	
	self.popupsize = Turbine.UI.Lotro.TextBox()
	self.popupsize:SetParent(self)
	self.popupsize:SetPosition(160,205)
	self.popupsize:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.popupsize:SetSize(50,25)
	self.popupsize:SetText("")
	
	self.popupsizeLabel = Turbine.UI.Label()
	self.popupsizeLabel:SetParent(self)
	self.popupsizeLabel:SetPosition(220,205)
	self.popupsizeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.popupsizeLabel:SetSize(100,25)
	self.popupsizeLabel:SetText("Pop-Up Size")
	
	self.toggleanchor = Turbine.UI.Lotro.CheckBox()
	self.toggleanchor:SetParent(self)
	self.toggleanchor:SetPosition(30,235)
	self.toggleanchor:SetSize(400,20)
	self.toggleanchor:SetText(" Toggle Anchor Position (Checked = on Icon)")
	
	self.toggelReset = Turbine.UI.Lotro.CheckBox()
	self.toggelReset:SetParent(self)
	self.toggelReset:SetPosition(30,265)
	self.toggelReset:SetSize(120,20)
	self.toggelReset:SetText(" Show Skill CD")
	
	self.toggelReset.CheckedChanged = function()
	
		if self.toggelReset:IsChecked() then
			self.resetTimer:SetEnabled(false)
		else
			self.resetTimer:SetEnabled(true)
		end
	
	end
	
	self.resetTimer = Turbine.UI.Lotro.TextBox()
	self.resetTimer:SetParent(self)
	self.resetTimer:SetPosition(160,263)
	self.resetTimer:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.resetTimer:SetSize(50,25)
	
	self.resetTimerLabel = Turbine.UI.Label()
	self.resetTimerLabel:SetParent(self)
	self.resetTimerLabel:SetPosition(220,265)
	self.resetTimerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.resetTimerLabel:SetSize(100,25)
	self.resetTimerLabel:SetText("Timer duration")
	
	self.fontLabel = Turbine.UI.Label()
	self.fontLabel:SetParent(self)
	self.fontLabel:SetPosition(30,295)
	self.fontLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.fontLabel:SetSize(50,25)
	self.fontLabel:SetText("Font")

	self.selectAlignment = LabelledComboBox(nil, nil, 160)
	self.selectAlignment:SetParent(self)
	self.selectAlignment:SetPosition(105,295)
	self.selectAlignment:AddItem("Top Left", 1)
	self.selectAlignment:AddItem("Top Center", 2)
	self.selectAlignment:AddItem("Top Right", 3)
	self.selectAlignment:AddItem("Middle Right", 4)
	self.selectAlignment:AddItem("Middle Center", 5)
	self.selectAlignment:AddItem("Middle Left", 6)
	self.selectAlignment:AddItem("Bottom Left", 7)
	self.selectAlignment:AddItem("Bottom Center", 8)
	self.selectAlignment:AddItem("Bottom Right", 9)
	
	self.selectFont = LabelledComboBox(nil, nil, 160)
	self.selectFont:SetParent(self)
	self.selectFont:SetPosition(275,295)
	self.selectFont:AddItem("Arial 12", 1);
	self.selectFont:AddItem("TrajanPro 13", 2);
	self.selectFont:AddItem("TrajanPro 14", 3);
	self.selectFont:AddItem("TrajanPro 15", 4);
	self.selectFont:AddItem("TrajanPro 16", 5);
	self.selectFont:AddItem("TrajanPro 18", 6);
	self.selectFont:AddItem("TrajanPro 19", 7);
	self.selectFont:AddItem("TrajanPro 20", 8);
	self.selectFont:AddItem("TrajanPro 21", 9);
	self.selectFont:AddItem("TrajanPro 23", 10);
	self.selectFont:AddItem("TrajanPro 24", 11);
	self.selectFont:AddItem("TrajanPro 25", 12);
	self.selectFont:AddItem("TrajanPro 26", 13);
	self.selectFont:AddItem("TrajanPro 28", 14);
	self.selectFont:AddItem("TrajanProBold 16", 15);
	self.selectFont:AddItem("TrajanProBold 22", 16);
	self.selectFont:AddItem("TrajanProBold 24", 17);
	self.selectFont:AddItem("TrajanProBold 25", 18);
	self.selectFont:AddItem("TrajanProBold 30", 19);
	self.selectFont:AddItem("TrajanProBold 36", 20);
	self.selectFont:AddItem("Verdana 10", 21);
	self.selectFont:AddItem("Verdana 12", 22);
	self.selectFont:AddItem("Verdana 14", 23);
	self.selectFont:AddItem("Verdana 16", 24);
	self.selectFont:AddItem("Verdana 18", 25);
	self.selectFont:AddItem("Verdana 20", 26);
	self.selectFont:AddItem("Verdana 22", 27);
	self.selectFont:AddItem("Verdana 23", 28);
	
	self.thresholdValue = Turbine.UI.Lotro.TextBox()
	self.thresholdValue:SetParent(self)
	self.thresholdValue:SetPosition(30,325)
	self.thresholdValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.thresholdValue:SetSize(50,25)
	
	self.thresholdValueLabel = Turbine.UI.Label()
	self.thresholdValueLabel:SetParent(self)
	self.thresholdValueLabel:SetPosition(90,325)
	self.thresholdValueLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.thresholdValueLabel:SetSize(200,25)
	self.thresholdValueLabel:SetText("Threshold value")

	self.thresholdLabel = Turbine.UI.Label()
	self.thresholdLabel:SetParent(self)
	self.thresholdLabel:SetPosition(30,355)
	self.thresholdLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.thresholdLabel:SetSize(70,25)
	self.thresholdLabel:SetText("Threshold")
	
	self.selectThresholdAlignment = LabelledComboBox(nil, nil, 160)
	self.selectThresholdAlignment:SetParent(self)
	self.selectThresholdAlignment:SetPosition(105,355)
	self.selectThresholdAlignment:AddItem("Top Left", 1)
	self.selectThresholdAlignment:AddItem("Top Center", 2)
	self.selectThresholdAlignment:AddItem("Top Right", 3)
	self.selectThresholdAlignment:AddItem("Middle Right", 4)
	self.selectThresholdAlignment:AddItem("Middle Center", 5)
	self.selectThresholdAlignment:AddItem("Middle Left", 6)
	self.selectThresholdAlignment:AddItem("Bottom Left", 7)
	self.selectThresholdAlignment:AddItem("Bottom Center", 8)
	self.selectThresholdAlignment:AddItem("Bottom Right", 9)
	
	self.selectThresholdFont = LabelledComboBox(nil, nil, 160)
	self.selectThresholdFont:SetParent(self)
	self.selectThresholdFont:SetPosition(275,355)
	self.selectThresholdFont:AddItem("Arial 12", 1);
	self.selectThresholdFont:AddItem("TrajanPro 13", 2);
	self.selectThresholdFont:AddItem("TrajanPro 14", 3);
	self.selectThresholdFont:AddItem("TrajanPro 15", 4);
	self.selectThresholdFont:AddItem("TrajanPro 16", 5);
	self.selectThresholdFont:AddItem("TrajanPro 18", 6);
	self.selectThresholdFont:AddItem("TrajanPro 19", 7);
	self.selectThresholdFont:AddItem("TrajanPro 20", 8);
	self.selectThresholdFont:AddItem("TrajanPro 21", 9);
	self.selectThresholdFont:AddItem("TrajanPro 23", 10);
	self.selectThresholdFont:AddItem("TrajanPro 24", 11);
	self.selectThresholdFont:AddItem("TrajanPro 25", 12);
	self.selectThresholdFont:AddItem("TrajanPro 26", 13);
	self.selectThresholdFont:AddItem("TrajanPro 28", 14);
	self.selectThresholdFont:AddItem("TrajanProBold 16", 15);
	self.selectThresholdFont:AddItem("TrajanProBold 22", 16);
	self.selectThresholdFont:AddItem("TrajanProBold 24", 17);
	self.selectThresholdFont:AddItem("TrajanProBold 25", 18);
	self.selectThresholdFont:AddItem("TrajanProBold 30", 19);
	self.selectThresholdFont:AddItem("TrajanProBold 36", 20);
	self.selectThresholdFont:AddItem("Verdana 10", 21);
	self.selectThresholdFont:AddItem("Verdana 12", 22);
	self.selectThresholdFont:AddItem("Verdana 14", 23);
	self.selectThresholdFont:AddItem("Verdana 16", 24);
	self.selectThresholdFont:AddItem("Verdana 18", 25);
	self.selectThresholdFont:AddItem("Verdana 20", 26);
	self.selectThresholdFont:AddItem("Verdana 22", 27);
	self.selectThresholdFont:AddItem("Verdana 23", 28);
	
	self.color = Turbine.UI.Lotro.TextBox()
	self.color:SetParent(self)
	self.color:SetPosition(30,385)
	self.color:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.color:SetSize(150,25)
	self.color:SetText("")
	
	self.colorSquare = Turbine.UI.Control()
	self.colorSquare:SetParent(self)
	self.colorSquare:SetPosition(190,385)
	self.colorSquare:SetSize(25,25)
	
	self.colorLabel = Turbine.UI.Label()
	self.colorLabel:SetParent(self)
	self.colorLabel:SetPosition(220,385)
	self.colorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.colorLabel:SetSize(150,25)
	self.colorLabel:SetText("Threshold font color (R,G,B)")
	

	self.new.Click = function(sender,args)

		self:GetParent():SaveChanges()
		CreateWindows()
	
		local value =  AddNewSkillTo(self:GetParent().selectedWindow)
		self:GetParent().selectedItem = value
		self:FillSelect(value)
		
	end
	
	self.quickslot.ShortcutChanged = function()
		
		if self.quickslot:GetShortcut():GetType() == Turbine.UI.Lotro.ShortcutType.Skill then
			
			local data = self.quickslot:GetShortcut():GetData()
			
			local name
			
			if classShortcut[me:GetClass()][data].en ~= nil then
				name = classShortcut[me:GetClass()][data].en
			else
				name = "ERROR"
			end

			self.quickslotLabel:SetText(name)
			
		end
			
	end

end
	
function ItemOptionControl:FillSelected(value, sender)

	if sender == self.select then

		self:GetParent().selectedItem = value

		local item = SaveFile[self:GetParent().selectedWindow][value]
		
		if item["data"] == nil then
			self.quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut())
		else
			self.quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Skill, item["data"]))
		end
		
		if SaveFile[self:GetParent().selectedWindow]["orientation"] then
			self.posUp:SetText("Up")
			self.posDown:SetText("Down")
		else
			self.posUp:SetText("Left")
			self.posDown:SetText("Right")
		end
		
		self.quickslotLabel:SetText(item["name"])
		self.showoffcd:SetChecked(item["showoffcd"])
		self.showoncd:SetChecked(item["showoncd"])
		self.cdopacity:SetText(item["cdopacity"])
		self.showpopup:SetChecked(item["showpopup"])
		self.popupsize:SetText(item["popupsize"])
		self.toggleanchor:SetChecked(item["popupanchor"])
		if item["resetTimer"] == 0 then
			self.toggelReset:SetChecked(true)
			self.resetTimer:SetEnabled(false)
		else
			self.toggelReset:SetChecked(false)
			self.resetTimer:SetEnabled(true)
		end
		if item["showpopup"]  then

			self.popupsize:SetEnabled(true)
			self.popupsizeLabel:SetEnabled(true)
			self.toggleanchor:SetEnabled(true)
		
		else
			self.popupsize:SetEnabled(false)
			self.popupsizeLabel:SetEnabled(false)
			self.toggleanchor:SetEnabled(false)

		end
		
		self.resetTimer:SetText(item["resetTimer"])	
		
		self.selectAlignment:SetSelection(item["alignment"])
		self.selectFont:SetSelection(item["font"])
		self.thresholdValue:SetText(item["thresholdValue"])
		self.selectThresholdAlignment:SetSelection(item["thresholdAlignment"])
		self.selectThresholdFont:SetSelection(item["thresholdFont"])
		if item["thresholdColor"] then
			self.color:SetText(math.floor(item["thresholdColor"]["R"]*255)..", "..math.floor(item["thresholdColor"]["G"]*255)..", "..math.floor(item["thresholdColor"]["B"]*255))
			self.colorSquare:SetBackColor(Turbine.UI.Color(item["thresholdColor"]["R"],item["thresholdColor"]["G"],item["thresholdColor"]["B"]))
		else
			self.color:SetText("255, 0, 0")
			self.colorSquare:SetBackColor(Turbine.UI.Color.Red)
		end
		
	
	end

end

function ItemOptionControl:FillEmpty()

	self:GetParent().selectedItem = -1
	
	self.quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut())
	self.quickslotLabel:SetText("")
	self.showoffcd:SetChecked(false)
	self.cdopacity:SetText("")
	self.showpopup:SetChecked(false)
	self.popupsize:SetText("")
	self.showoncd:SetChecked(false)
	self.toggleanchor:SetChecked(false)


end

function ItemOptionControl:FillSelect(selected)

	local window = self:GetParent().selectedWindow
	
	self.select:Clear()
	
	if table.getn(SaveFile) > 0 then
		if table.getn(SaveFile[window]) > 0 then
			
			self.select:Clear()
			for i,items in ipairs(SaveFile[window]) do
				self.select:AddItem(items["name"],i,i)
			end
			self:GetParent().selectedItem = selected
			self.select:SetSelection(selected)
			self:FillSelected(self:GetParent().selectedItem, self.select)
			
		else
		
			self:FillEmpty()
			
		end		
	end

end

function ItemOptionControl:UpdateContent()

	self:FillSelect(1)
	
end

function ItemOptionControl:UpdateColor()

	self.colorSquare:SetBackColor(Turbine.UI.Color(SaveFile[self:GetParent().selectedWindow][self:GetParent().selectedItem]["thresholdColor"]["R"],SaveFile[self:GetParent().selectedWindow][self:GetParent().selectedItem]["thresholdColor"]["G"],SaveFile[self:GetParent().selectedWindow][self:GetParent().selectedItem]["thresholdColor"]["B"]))

end









